// Plugin Developed by Astoria
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Plugins;

using System.Collections.Generic;
using System.Linq;

using System;
using System.Windows.Media;

namespace BeRude
{
    public class BeRude : HBPlugin
    {
        public override string Name { get { return "BeRude"; } }
        public override string Author { get { return "Astoria"; } }
        public override Version Version { get { return _version; } }
        private readonly Version _version = new Version(1, 0, 0, 0);
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        public static bool gotTarget { get { return Me.CurrentTarget != null; } }
        public static bool notMe { get { return Me.CurrentTarget != StyxWoW.Me; } }

        public static DateTime _checkTimer;

        public override void OnEnable()
        {
            base.OnEnable();
            Logging.Write(Colors.OrangeRed, "BeRude by Astoria Enable");
            _checkTimer = DateTime.Now + new TimeSpan(0, 0, 0, 4, 0);
        }

        public override void OnDisable()
        {
            Logging.Write(Colors.OrangeRed, "BeRude Disable.");
            base.OnDisable();
        }

        public static bool goodDistance(float range)
        {
            return Me.CurrentTarget.Location.Distance(Me.Location) <= range;
        }

        public override void Pulse()
        {
            if (DateTime.Now >= _checkTimer 
                && gotTarget 
                && Me.CurrentTarget.HealthPercent < new Random().Next(15, 30) // Be more human !
                && notMe
                && goodDistance(20) 
                && !Me.CurrentTarget.IsFriendly 
                && Me.CurrentTarget.IsAlive 
                && !Me.CurrentTarget.IsNeutral
                && !Me.CurrentTarget.IsPet
                && !Me.CurrentTarget.IsTotem)
            {
                string[] emote = {
                    "spit",
                    "bye",
                    "rude",
                    "bored",
                    "lol",
                    "insult",
                    "flex",
                    "strut",
                    "Fatality Baby",
                    "Execution Baby",
                    "Can you feel it ?",
                    "chicken" };

                Random rand = new Random();

                int r = rand.Next(10);

                string result = emote[r];
                if(result != "Fatality")
                    Lua.DoString("RunMacroText(\"/"+ result + "\")");
                if (result == "Fatality Baby" || result == "Execution Baby" || result == "Can you feel it ?")
                    Lua.DoString("RunMacroText(\"/yell " + result + "\")");

                _checkTimer = DateTime.Now + new TimeSpan(0, 0, 0, 4, 0);
            }
        }
    }
}